#!/bin/perl
#################################################################################
# Created       : Martin Foster
# Modified      : 19-May-2003
#################################################################################
#
# Global Who - Script part of Ethereal Realms designed to list who is currently on
# Copyright (C) 2000-2003 Martin Foster
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# Author of this script can be contacted at the following:
#       E-Mail  : martin@ethereal-realms.org
#       Address : 204 - 817, 5th Street NE
#                 Calgary, Alberta
#                 T2E 3W9
#
#################################################################################

use CGI qw(:standard);						# Common gateway interface
use CGI::Carp qw(fatalsToBrowser);				# CGI Error logs
use strict;							# Strict variable enforcement

use eRealms::Database;						# Database handler
use eRealms::Param;						# Parameter control
use eRealms::Template;						# Template handler
use eRealms::Who;						# Who is on


#################################################################################
# Data Members
#################################################################################
my $cgi;							# Common gateway interface handle
my $database;							# Database handle
my $param;							# Parameter handle
my $who;							# Who handle
my $tmpl;							# Template handle

my %realm;							# Realm hash


#################################################################################
# Program Area
#################################################################################

	# Initial handles
	$cgi      = new CGI;	
	$database = new eRealms::Database();

	# Connect and fetch
	$database->Connect();	

	# Parameter handling
	$param = new eRealms::Param($database, $cgi);
	$param->GetParam();
	
	# Link with hash
	$database->GetHashRealm(\%realm);

	# Instance
	$tmpl = new eRealms::Template(\%realm);


	# Document header
	print $cgi->header();
	$database->DocumentGetHeader();
	
	# Display title
	$tmpl->ShowMain($realm{'TagTitleWho'});

	# Link to Portal
	$tmpl->Show('TmplWho', MLINK=>$realm{LnkPortal}) unless (defined($param->{'USER'}));

	# Display who is on
	$who = new eRealms::Who($database, $cgi, $param);
	$who->WhoAdvanced(\%realm);

	# Document footer
	$database->DocumentGetFooter();
